import { __awaiter, __generator } from "tslib";
import { ModulePrefix } from './../../index';
import axios from "axios";
import * as types from "./mutation-types";
export var actions = {
    load: function (_a, _b) {
        var commit = _a.commit, rootState = _a.rootState, state = _a.state;
        var slug = _b.slug, _c = _b.type, type = _c === void 0 ? 'pages' : _c, _d = _b.embed, embed = _d === void 0 ? false : _d, _e = _b.beforeSave, beforeSave = _e === void 0 ? null : _e, _f = _b.beforeRequest, beforeRequest = _f === void 0 ? null : _f, _g = _b.beforeSaveFailed, beforeSaveFailed = _g === void 0 ? null : _g;
        return __awaiter(this, void 0, void 0, function () {
            var config, typeBaseUrl, prefix, embedString, halfBase, base, requestUrl, _h, response, data, _j, err_1, data, _k;
            return __generator(this, function (_l) {
                switch (_l.label) {
                    case 0:
                        config = rootState[ModulePrefix + "_config"];
                        typeBaseUrl = "/wp-json/wp/v2/" + type;
                        if (config.requestPrefix &&
                            config.requestPrefix.length > 0) {
                            prefix = config.requestPrefix;
                            if (prefix.endsWith("/")) {
                                prefix = prefix.substring(0, -1);
                            }
                            if (prefix.startsWith("/")) {
                                prefix = prefix.substr(1);
                            }
                            typeBaseUrl = "/" + prefix + typeBaseUrl;
                        }
                        embedString = embed ? "_embed" : "";
                        halfBase = config.url.endsWith("/")
                            ? config.url.substr(0, config.url.length - 1) + typeBaseUrl
                            : config.url + typeBaseUrl;
                        base = slug === ""
                            ? "" + halfBase + (embedString ? "?" + embedString : embedString)
                            : halfBase + "?slug=" + slug + (embedString ? "&" + embedString : embedString);
                        _l.label = 1;
                    case 1:
                        _l.trys.push([1, 11, , 15]);
                        if (!(!state.types[type] || !state.types[type][slug])) return [3 /*break*/, 9];
                        if (!beforeRequest) return [3 /*break*/, 3];
                        return [4 /*yield*/, beforeRequest(base)];
                    case 2:
                        _h = _l.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        _h = base;
                        _l.label = 4;
                    case 4:
                        requestUrl = _h;
                        return [4 /*yield*/, axios.get(requestUrl)];
                    case 5:
                        response = _l.sent();
                        if (config.debugger) {
                            console.log("[VueWordpress][Debugger] I've just fetched " + base);
                        }
                        if (response.data.status == 404) {
                            throw new Error("[VueWordpress] Error 404 in " + base + " endpoint");
                        }
                        if (response.data.length < 1) {
                            throw new Error("[VueWordpress] Empty data in " + base + " endpoint");
                        }
                        if (!beforeSave) return [3 /*break*/, 7];
                        return [4 /*yield*/, beforeSave(response.data)];
                    case 6:
                        _j = _l.sent();
                        return [3 /*break*/, 8];
                    case 7:
                        _j = response.data;
                        _l.label = 8;
                    case 8:
                        data = _j;
                        commit(types.SET_POST_CONTENT, {
                            data: data,
                            slotName: slug,
                            type: type
                        });
                        return [3 /*break*/, 10];
                    case 9:
                        if (config.debugger) {
                            console.log("[VueWordpress][Debugger] Did not fetch " + base + " because it is yet in the store");
                        }
                        _l.label = 10;
                    case 10: return [3 /*break*/, 15];
                    case 11:
                        err_1 = _l.sent();
                        console.log("[VueWordpress][Debugger] Could not fetch because of error", err_1);
                        if (!beforeSaveFailed) return [3 /*break*/, 13];
                        return [4 /*yield*/, beforeSaveFailed()];
                    case 12:
                        _k = _l.sent();
                        return [3 /*break*/, 14];
                    case 13:
                        _k = false;
                        _l.label = 14;
                    case 14:
                        data = _k;
                        commit(types.SET_POST_CONTENT, {
                            data: data,
                            slotName: slug,
                            type: type
                        });
                        return [3 /*break*/, 15];
                    case 15: return [2 /*return*/];
                }
            });
        });
    }
};
//# sourceMappingURL=actions.js.map